summaryrefslogtreecommitdiffstats
path: root/source/ap/rpm/rpm.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'source/ap/rpm/rpm.SlackBuild')
-rwxr-xr-xsource/ap/rpm/rpm.SlackBuild122
1 files changed, 122 insertions, 0 deletions
diff --git a/source/ap/rpm/rpm.SlackBuild b/source/ap/rpm/rpm.SlackBuild
new file mode 100755
index 000000000..a16f0a3ea
--- /dev/null
+++ b/source/ap/rpm/rpm.SlackBuild
@@ -0,0 +1,122 @@
+#!/bin/sh
+
+# Copyright 2008, 2009 Patrick J. Volkerding, Sebeka, MN, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+# Build RPM (of all things) for Slackware.
+
+VERSION=${VERSION:-4.7.0}
+ARCH=${ARCH:-x86_64}
+BUILD=${BUILD:-2}
+
+NUMJOBS=${NUMJOBS:-" -j7 "}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+elif [ "$ARCH" = "arm" ]; then
+ SLKCFLAGS="-O2 -march=armv4 -mtune=xscale"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "armel" ]; then
+ SLKCFLAGS="-O2 -march=armv4t"
+ LIBDIRSUFFIX=""
+fi
+
+NSS_INC="/usr/include/seamonkey/nss"
+NSPR_INC="/usr/include/seamonkey/nspr"
+DB_INC="/usr/include/db44"
+NSS_LIBS="/usr/lib${LIBDIRSUFFIX}/seamonkey"
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=/tmp/package-rpm
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+
+cd $TMP
+rm -rf rpm-$VERSION
+xz -dc $CWD/rpm-$VERSION.tar.xz | tar xvf - || exit 1
+cd rpm-$VERSION
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+# We have to tell it where to find Seamonkey's NSS.
+# Also, --enable-sqlite3 needs "-ldl" in LDFLAGS
+# And --enable-broken-chown fits, as ours follows symlinks.
+CFLAGS="$SLKCFLAGS -I$NSS_INC -I$NSPR_INC -I$DB_INC" \
+LDFLAGS="-L${NSS_LIBS} -ldl" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --enable-python \
+ --with-external-db \
+ --enable-broken-chown \
+ --without-hackingdocs \
+ --without-selinux \
+ --without-lua \
+ --without-dmalloc \
+ --enable-sqlite3 \
+ --build=$ARCH-slackware-linux
+
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG || exit 1
+
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+
+# Here's a bug - /var/tmp should NOT have mode 0755
+rmdir $PKG/var/tmp || exit 1
+
+# Compress man pages
+( cd $PKG/usr/man
+ find . -type f -exec gzip -9 {} \;
+ for i in $(find . -type l) ; do ln -s $(readlink $i).gz $i.gz ; rm $i ; done
+)
+
+# Initialize a dummy package database
+mkdir -p $PKG/var/lib/rpm/tmp
+zcat $CWD/Packages.gz > $PKG/var/lib/rpm/tmp/Packages
+
+# Install docs
+mkdir -p $PKG/usr/doc/rpm-$VERSION
+cp -a \
+ CHANGES COPYING CREDITS GROUPS INSTALL README TODO doc/manual \
+ $PKG/usr/doc/rpm-$VERSION
+
+mkdir -p $PKG/install
+zcat $CWD/doinst.sh.gz > $PKG/install/doinst.sh
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $TMP/rpm-$VERSION-$ARCH-$BUILD.txz
+